## hyprland-qt-support 0.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(GNUInstallDirs)
include(cmake/install-qml-module.cmake)

option(BUILD_TESTER "Build style tester" OFF)

# Get version
file(READ "${CMAKE_SOURCE_DIR}/VERSION" VER_RAW)
string(STRIP ${VER_RAW} VER)

project(hyprland-qt-support VERSION ${VER} LANGUAGES CXX)

find_package(Qt6 6.6 REQUIRED COMPONENTS Qml Quick QuickControls2)
find_package(PkgConfig REQUIRED)

pkg_check_modules(hyprlang REQUIRED IMPORTED_TARGET hyprlang>=0.6.0)

qt_standard_project_setup(REQUIRES 6.6)
set(QT_QML_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/qml)

add_subdirectory(src)

=== Makefile ===
.PHONY: all
all: build
	cmake --build build

build:
	cmake -GNinja -B build -DCMAKE_BUILD_TYPE=RelWithDebInfo

.PHONY: dev
dev:
	CMAKE_EXPORT_COMPILE_COMMANDS=1 cmake -GNinja -B build -DCMAKE_BUILD_TYPE=Debug
	ln -sf build/compile_commands.json .

.PHONY: fmt
fmt:
	find src -type f \( -name "*.cpp" -o -name "*.hpp" \) -print0 | xargs -0 clang-format -i

.PHONY: lint
lint:
	find src -type f -name "*.cpp" -print0 | parallel -q0 --eta clang-tidy

.PHONY: clean
clean:
	rm -rf build
	rm -f compile_commands.json

=== src/CMakeLists.txt ===
add_subdirectory(style)

=== src/style/CMakeLists.txt ===
add_subdirectory(impl)

qt_add_qml_module(hyprland-quick-style SHARED
    URI org.hyprland.style
    VERSION 0.1
    PLUGIN_TARGET hyprland-quick-styleplugin
    NO_PLUGIN_OPTIONAL
    NO_GENERATE_PLUGIN_SOURCE
    CLASS_NAME HyprlandQuickStylePlugin
    IMPORTS
        org.hyprland.style.impl
        QtQuick.Controls.Basic
    QML_FILES
        Button.qml
        CheckBox.qml
        TextField.qml
)

target_sources(hyprland-quick-styleplugin PRIVATE plugin.cpp)
target_link_libraries(hyprland-quick-styleplugin PRIVATE Qt::Gui)

target_link_libraries(hyprland-quick-style PRIVATE hyprland-quick-style-impl)

install_qml_module(hyprland-quick-style)

if (BUILD_TESTER)
    add_subdirectory(test)
endif()

=== src/style/impl/CMakeLists.txt ===
set_source_files_properties(HyprlandStyle.qml PROPERTIES QT_QML_SINGLETON_TYPE TRUE)

qt_add_library(hyprland-quick-style-impl SHARED
    hyprlandstyle.cpp
    checkdelegate.cpp
)

qt_add_qml_module(hyprland-quick-style-impl
    URI org.hyprland.style.impl
    VERSION 0.1
    QML_FILES
        HyprlandStyle.qml
        MotionBehavior.qml
)

target_link_libraries(hyprland-quick-style-impl PRIVATE Qt::Quick hyprlang)

install_qml_module(hyprland-quick-style-impl)

=== src/style/test/CMakeLists.txt ===
qt_add_executable(style-test main.cpp)

qt_add_qml_module(style-test
    URI org.hyprland.style.test
    IMPORTS
        org.hyprland.style
    QML_FILES
        main.qml
)

target_link_libraries(style-test PRIVATE Qt::Quick Qt::QuickControls2)

=== debian/changelog ===
hyprland-qt-support (0.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1110116)

 -- Carl Keinath <carl.keinath@gmail.com>  Wed, 27 Aug 2025 08:31:39 +0200

=== debian/control ===
Source: hyprland-qt-support
Section: libs
Priority: optional
Maintainer: Debian Hyprland Maintainers <team+hyprland@tracker.debian.org>
Uploaders:
 Carl Keinath <carl.keinath@gmail.com>,
 Chow Loong Jin <hyperair@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkgconf,
 libhyprlang-dev (>= 0.6.0),
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-wayland-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/hyprwm/hyprland-qt-support
Vcs-Browser: https://salsa.debian.org/hyprland-team/hyprland-qt-support
Vcs-Git: https://salsa.debian.org/hyprland-team/hyprland-qt-support.git

Package: qml6-module-org-hyprland-style
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Qt6 QML style provider for Hyprland applications
 hyprland-qt-support provides the Hyprland-specific Qt Quick Controls 2 style
 plugin. Applications can use it by setting
 QT_QUICK_CONTROLS_STYLE=org.hyprland.style.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- \
        -DCMAKE_BUILD_TYPE=Release \
        -DINSTALL_QML_PREFIX=lib/$(DEB_HOST_MULTIARCH)/qt6/qml \

=== debian/watch ===
Version: 5

Template: Github
Owner: hyprwm
Project: hyprland-qt-support
